<script setup lang="ts">
import { computed, onMounted, reactive } from "vue";
import type {
  BucketOut,
  OwnershipTransferRequestOut,
} from "@/client/types.gen";
import { OwnershipTypeEnum } from "@/client/types.gen";
import { useRouter } from "vue-router";
import FontAwesomeIcon from "@/components/FontAwesomeIcon.vue";
import CreateBucketModal from "@/components/object-storage/modals/CreateBucketModal.vue";
import BucketListItem from "@/components/object-storage/BucketListItem.vue";
import { useBucketStore } from "@/stores/buckets";
import { Modal, Tooltip } from "bootstrap";
import { useUserStore } from "@/stores/users";
import { useSettingsStore } from "@/stores/settings";
import { useOTRStore } from "@/stores/otrs";
import BucketDetailModal from "@/components/object-storage/modals/BucketDetailModal.vue";
import ListOtrsModal from "@/components/modals/ListOtrsModal.vue";
import OtrModal from "@/components/modals/ShowOtrModal.vue";
import DeleteBucketModal from "@/components/object-storage/modals/DeleteBucketModal.vue";

const router = useRouter();
const bucketRepository = useBucketStore();
const authStore = useUserStore();
const settingsStore = useSettingsStore();
const otrRepository = useOTRStore();

const props = defineProps<{
  bucketName?: string;
}>();

const bucketsState = reactive<{
  loading: boolean;
  filterString: string;
  potentialDeleteBucketName: string;
  bucketOtrTarget: string;
  bucketDetails: BucketOut;
}>({
  filterString: "",
  potentialDeleteBucketName: "",
  loading: true,
  bucketOtrTarget: "",
  bucketDetails: {
    name: "",
    created_at: 0,
    description: "",
    public: false,
    owner_id: "",
  },
});
let deleteModal: Modal | null = null;
let showOtrModalInstance: Modal | null = null;
let detailModal: Modal | null = null;
let refreshTimeout: NodeJS.Timeout | undefined = undefined;

function fetchBuckets() {
  otrRepository.fetchOwnOtrs(OwnershipTypeEnum.BUCKET);
  bucketRepository.fetchOwnPermissions();
  bucketRepository
    .fetchOwnBuckets(() => {
      bucketsState.loading = false;
    })
    .then((buckets) => {
      buckets
        .filter((bucket) => bucket.owner_id === authStore.currentUID)
        .map((bucket) => bucketRepository.fetchBucketPermissions(bucket.name));
    });
}

const filteredBuckets = computed<BucketOut[]>(() => {
  return bucketsState.filterString.length > 0
    ? bucketRepository.buckets.filter((bucket) =>
        bucket.name.includes(bucketsState.filterString),
      )
    : bucketRepository.buckets;
});

const otrForNewBuckets = computed<OwnershipTransferRequestOut[]>(() =>
  otrRepository.bucketOtrs.filter(
    (otr) => otr.new_owner_uid === authStore.currentUID,
  ),
);

function showOtrModal(bucketName: string) {
  bucketsState.bucketOtrTarget = bucketName;
  showOtrModalInstance?.show();
}

function showDetailModal(bucket: BucketOut) {
  bucketsState.bucketDetails = bucket;
  detailModal?.show();
}

function deleteBucket(bucketName: string) {
  bucketsState.potentialDeleteBucketName = bucketName;
  deleteModal?.show();
}

function confirmedDeleteBucket(bucketName: string) {
  bucketRepository.deleteBucket(bucketName).then(() => {
    router.push({ name: "buckets" });
  });
}

function refreshBuckets() {
  clearTimeout(refreshTimeout);
  refreshTimeout = setTimeout(() => {
    fetchBuckets();
  }, 500);
}

onMounted(() => {
  deleteModal = Modal.getOrCreateInstance("#delete-bucket-modal");
  showOtrModalInstance = Modal.getOrCreateInstance("#view-bucket-otr-modal");
  detailModal = Modal.getOrCreateInstance("#view-bucket-details-modal");
  fetchBuckets();
  new Tooltip("#refreshBucketButton");
  new Tooltip("#showBucketOtrsButtons");
  if (!authStore.foreignUser) {
    new Tooltip("#createBucketButton");
  }
});
</script>

<template>
  <delete-bucket-modal
    modal-id="delete-bucket-modal"
    :bucket="
      bucketRepository.bucketMapping[bucketsState.potentialDeleteBucketName]
    "
    @confirm-delete="confirmedDeleteBucket"
  />
  <CreateBucketModal
    v-if="!authStore.foreignUser"
    modal-id="create-bucket-modal"
  />
  <otr-modal
    :otr-target-id="bucketsState.bucketOtrTarget"
    modal-id="view-bucket-otr-modal"
  />
  <list-otrs-modal
    :otrs="otrForNewBuckets"
    :otr-type="OwnershipTypeEnum.BUCKET"
    modal-id="list-bucket-otrs-modal"
  />
  <bucket-detail-modal
    modal-id="view-bucket-details-modal"
    :bucket="bucketsState.bucketDetails"
  />
  <div class="row border-bottom">
    <h2 class="mb-2">My Data Buckets</h2>
  </div>
  <div class="row mt-4">
    <div class="col-3">
      <div class="d-flex justify-content-between">
        <button
          id="refreshBucketButton"
          type="button"
          class="btn border shadow-sm"
          :class="{
            'btn-light': settingsStore.lightThemeActive,
            'btn-secondary': settingsStore.darkThemeActive,
          }"
          data-bs-title="Refresh Data Buckets"
          data-bs-toggle="tooltip"
          @click="refreshBuckets"
        >
          <font-awesome-icon
            icon="fa-solid fa-arrow-rotate-right"
            class="fs-5"
          />
          <span class="visually-hidden">Refresh Data Buckets</span>
        </button>
        <button
          id="showBucketOtrsButtons"
          :hidden="otrForNewBuckets.length === 0"
          class="btn border shadow-sm position-relative"
          :class="{
            'btn-light': settingsStore.lightThemeActive,
            'btn-secondary': settingsStore.darkThemeActive,
          }"
          data-bs-title="Ownership transfer requests"
          data-bs-target="#list-bucket-otrs-modal"
          data-bs-toggle="modal"
        >
          Requests
          <span
            class="position-absolute top-0 start-100 translate-middle badge rounded-pill bg-danger"
            style="font-size: 0.8em"
          >
            {{ otrForNewBuckets.length }}
            <span class="visually-hidden"
              >open bucket ownership transfer requests</span
            >
          </span>
        </button>
        <button
          v-if="!authStore.foreignUser"
          id="createBucketButton"
          type="button"
          class="btn border shadow-sm"
          :class="{
            'btn-light': settingsStore.lightThemeActive,
            'btn-secondary': settingsStore.darkThemeActive,
          }"
          data-bs-toggle="modal"
          data-bs-title="Create New Data Bucket"
          data-bs-target="#create-bucket-modal"
        >
          <font-awesome-icon icon="fa-solid fa-plus" class="fs-5" />
          <span class="visually-hidden">Create New Data Bucket</span>
        </button>
      </div>
      <div class="input-group mt-2 rounded shadow-sm">
        <span id="buckets-search-wrapping" class="input-group-text"
          ><font-awesome-icon icon="fa-solid fa-magnifying-glass"
        /></span>
        <input
          id="filterBucketNameInput"
          v-model.trim="bucketsState.filterString"
          type="search"
          class="form-control"
          placeholder="Search Buckets"
          aria-label="Search Buckets"
          aria-describedby="buckets-search-wrapping"
        />
      </div>

      <div class="list-group mt-3">
        <div v-if="!bucketsState.loading">
          <div v-if="filteredBuckets.length > 0">
            <bucket-list-item
              v-for="bucket in filteredBuckets"
              :key="bucket.name"
              :active="props.bucketName === bucket.name"
              :deletable="!authStore.foreignUser"
              :bucket="bucket"
              :loading="false"
              @click-delete-bucket="deleteBucket"
              @click-show-otr="showOtrModal"
              @click-bucket-detail="showDetailModal"
            />
          </div>
          <div v-else class="text-center fs-2 mt-5">
            <font-awesome-icon
              icon="fa-solid fa-magnifying-glass"
              class="mb-2 fs-0"
              style="color: var(--bs-secondary)"
            />
            <br />
            Could not find any Buckets
          </div>
        </div>
        <div v-else>
          <bucket-list-item
            v-for="n in 5"
            :key="n"
            :active="false"
            loading
            :deletable="false"
            :bucket="{
              name: '',
              description: '',
              created_at: 0,
              owner_id: '',
              public: false,
            }"
          ></bucket-list-item>
        </div>
      </div>
    </div>
    <div class="col-9">
      <router-view></router-view>
      <div
        v-if="router.currentRoute.value.name === 'buckets'"
        class="text-center mt-5"
      >
        <font-awesome-icon
          icon="fa-solid fa-hand-pointer"
          class="mb-5"
          style="color: var(--bs-secondary); font-size: 5em"
        />
        <p class="fs-2">Click on a bucket to browse its content</p>
      </div>
    </div>
  </div>
</template>

<style scoped></style>
